"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
exports.__esModule = true;
var React = require("react");
var Mark_1 = require("./Mark");
var utils_1 = require("./utils");
var Split = function (props) {
    if (props.mark)
        return React.createElement(Mark_1["default"], __assign({}, props));
    return (React.createElement("span", { "data-start": props.start, "data-end": props.end, onClick: function () { return props.onClick({ start: props.start, end: props.end }); } }, props.content));
};
// TODO: When React 16.3 types are ready, remove casts.
var TextAnnotator = /** @class */ (function (_super) {
    __extends(TextAnnotator, _super);
    function TextAnnotator(props) {
        var _this = _super.call(this, props) || this;
        _this.handleMouseUp = function () {
            var _a;
            if (!_this.props.onChange)
                return;
            var selection = window.getSelection();
            console.log(selection, 'seleção');
            if (utils_1.selectionIsEmpty(selection))
                return;
            var start = parseInt(selection.anchorNode.parentElement.getAttribute('data-start'), 10) +
                selection.anchorOffset;
            var end = parseInt(selection.focusNode.parentElement.getAttribute('data-start'), 10) +
                selection.focusOffset;
            if (utils_1.selectionIsBackwards(selection)) {
                ;
                _a = [end, start], start = _a[0], end = _a[1];
            }
            _this.props.onChange(_this.props.value.concat([
                _this.getSpan({ start: start, end: end, text: _this.props.content.slice(start, end) }),
            ]));
            window.getSelection().empty();
        };
        _this.handleSplitClick = function (_a) {
            var start = _a.start, end = _a.end;
            // Find and remove the matching split.
            var splitIndex = _this.props.value.findIndex(function (s) { return s.start === start && s.end === end; });
            if (splitIndex >= 0) {
                _this.props.onChange(_this.props.value.slice(0, splitIndex).concat(_this.props.value.slice(splitIndex + 1)));
            }
        };
        _this.getSpan = function (span) {
            if (_this.props.getSpan)
                return _this.props.getSpan(span);
            return span;
        };
        _this.rootRef = React.createRef();
        return _this;
    }
    TextAnnotator.prototype.componentDidMount = function () {
        this.rootRef.current.addEventListener('mouseup', this.handleMouseUp);
    };
    TextAnnotator.prototype.componentWillUnmount = function () {
        this.rootRef.current.removeEventListener('mouseup', this.handleMouseUp);
    };
    TextAnnotator.prototype.render = function () {
        var _this = this;
        var _a = this.props, content = _a.content, value = _a.value, style = _a.style;
        var splits = utils_1.splitWithOffsets(content, value);
        return (React.createElement("div", { style: style, ref: this.rootRef }, splits.map(function (split) { return (React.createElement(Split, __assign({ key: split.start + "-" + split.end }, split, { wordsToBold: _this.props.wordsToBold, onClick: _this.handleSplitClick }))); })));
    };
    return TextAnnotator;
}(React.Component));
exports["default"] = TextAnnotator;
//# sourceMappingURL=TextAnnotator.js.map